package networkelement

import (
	"context"

	"code.fbi.h-da.de/danet/gosdn/controller/store"
)

// Store describes an interface for network element store implementations.
type Store interface {
	Add(context.Context, NetworkElement) error
	Update(context.Context, NetworkElement) error
	Delete(context.Context, NetworkElement) error
	Get(context.Context, store.Query) (LoadedNetworkElement, error)
	GetAll(context.Context) ([]LoadedNetworkElement, error)
}
